Index: /LMDZ5/trunk/libf/phylmd/phys_output_mod.F90
===================================================================
--- /LMDZ5/trunk/libf/phylmd/phys_output_mod.F90	(revision 1538)
+++ /LMDZ5/trunk/libf/phylmd/phys_output_mod.F90	(revision 1539)
@@ -1157,99 +1456,233 @@
    type_ecri(4) = 't_max(X)'
    type_ecri(5) = 't_max(X)'
- CALL histdef3d(iff,o_tke_max%flag,o_tke_max%name, "TKE max", "m2/s2")
+   type_ecri(6) = 't_max(X)'
+   CALL histdef3d(iff,clef_stations(iff), &
+   o_kz_max%flag,o_kz_max%name, "Kz melange max", "m2/s" )
+  ENDIF
    type_ecri(:) = type_ecri_files(:)
-     endif
-
- CALL histdef3d(iff,o_kz%flag,o_kz%name, "Kz melange", "m2/s")
-   type_ecri(1) = 't_max(X)'
-   type_ecri(2) = 't_max(X)'
-   type_ecri(3) = 't_max(X)'
-   type_ecri(4) = 't_max(X)'
-   type_ecri(5) = 't_max(X)'
- CALL histdef3d(iff,o_kz_max%flag,o_kz_max%name, "Kz melange max", "m2/s" )
-   type_ecri(:) = type_ecri_files(:)
- CALL histdef3d(iff,o_clwcon%flag,o_clwcon%name, "Convective Cloud Liquid water content", "kg/kg") 
- CALL histdef3d(iff,o_dtdyn%flag,o_dtdyn%name, "Dynamics dT", "K/s")
- CALL histdef3d(iff,o_dqdyn%flag,o_dqdyn%name, "Dynamics dQ", "(kg/kg)/s")
- CALL histdef3d(iff,o_dudyn%flag,o_dudyn%name, "Dynamics dU", "m/s2")
- CALL histdef3d(iff,o_dvdyn%flag,o_dvdyn%name, "Dynamics dV", "m/s2")
- CALL histdef3d(iff,o_dtcon%flag,o_dtcon%name, "Convection dT", "K/s")
- CALL histdef3d(iff,o_ducon%flag,o_ducon%name, "Convection du", "m/s2")
- CALL histdef3d(iff,o_dqcon%flag,o_dqcon%name, "Convection dQ", "(kg/kg)/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_clwcon%flag,o_clwcon%name, "Convective Cloud Liquid water content", "kg/kg") 
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dtdyn%flag,o_dtdyn%name, "Dynamics dT", "K/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dqdyn%flag,o_dqdyn%name, "Dynamics dQ", "(kg/kg)/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dudyn%flag,o_dudyn%name, "Dynamics dU", "m/s2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dvdyn%flag,o_dvdyn%name, "Dynamics dV", "m/s2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dtcon%flag,o_dtcon%name, "Convection dT", "K/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_ducon%flag,o_ducon%name, "Convection du", "m/s2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dqcon%flag,o_dqcon%name, "Convection dQ", "(kg/kg)/s")
 
 ! Wakes
  IF(iflag_con.EQ.3) THEN
  IF (iflag_wake >= 1) THEN
-   CALL histdef2d(iff,o_ale_wk%flag,o_ale_wk%name, "ALE WK", "m2/s2")
-   CALL histdef2d(iff,o_alp_wk%flag,o_alp_wk%name, "ALP WK", "m2/s2")
-   CALL histdef2d(iff,o_ale%flag,o_ale%name, "ALE", "m2/s2")
-   CALL histdef2d(iff,o_alp%flag,o_alp%name, "ALP", "W/m2")
-   CALL histdef2d(iff,o_cin%flag,o_cin%name, "Convective INhibition", "m2/s2")
-   CALL histdef2d(iff,o_wape%flag,o_WAPE%name, "WAPE", "m2/s2")
-   CALL histdef2d(iff,o_wake_h%flag,o_wake_h%name, "wake_h", "-")
-   CALL histdef2d(iff,o_wake_s%flag,o_wake_s%name, "wake_s", "-")
-   CALL histdef3d(iff,o_dtwak%flag,o_dtwak%name, "Wake dT", "K/s")
-   CALL histdef3d(iff,o_dqwak%flag,o_dqwak%name, "Wake dQ", "(kg/kg)/s")
-   CALL histdef3d(iff,o_wake_deltat%flag,o_wake_deltat%name, "wake_deltat", " ")
-   CALL histdef3d(iff,o_wake_deltaq%flag,o_wake_deltaq%name, "wake_deltaq", " ")
-   CALL histdef3d(iff,o_wake_omg%flag,o_wake_omg%name, "wake_omg", " ")
+   CALL histdef2d(iff,clef_stations(iff), &
+o_ale_wk%flag,o_ale_wk%name, "ALE WK", "m2/s2")
+   CALL histdef2d(iff,clef_stations(iff), &
+o_alp_wk%flag,o_alp_wk%name, "ALP WK", "m2/s2")
+   CALL histdef2d(iff,clef_stations(iff), &
+o_ale%flag,o_ale%name, "ALE", "m2/s2")
+   CALL histdef2d(iff,clef_stations(iff), &
+o_alp%flag,o_alp%name, "ALP", "W/m2")
+   CALL histdef2d(iff,clef_stations(iff),o_cin%flag,o_cin%name, "Convective INhibition", "m2/s2")
+   CALL histdef2d(iff,clef_stations(iff),o_wape%flag,o_WAPE%name, "WAPE", "m2/s2")
+   CALL histdef2d(iff,clef_stations(iff),o_wake_h%flag,o_wake_h%name, "wake_h", "-")
+   CALL histdef2d(iff,clef_stations(iff),o_wake_s%flag,o_wake_s%name, "wake_s", "-")
+   CALL histdef3d(iff,clef_stations(iff),o_dtwak%flag,o_dtwak%name, "Wake dT", "K/s")
+   CALL histdef3d(iff,clef_stations(iff),o_dqwak%flag,o_dqwak%name, "Wake dQ", "(kg/kg)/s")
+   CALL histdef3d(iff,clef_stations(iff),o_wake_deltat%flag,o_wake_deltat%name, "wake_deltat", " ")
+   CALL histdef3d(iff,clef_stations(iff),o_wake_deltaq%flag,o_wake_deltaq%name, "wake_deltaq", " ")
+   CALL histdef3d(iff,clef_stations(iff),o_wake_omg%flag,o_wake_omg%name, "wake_omg", " ")
  ENDIF
-   CALL histdef3d(iff,o_Vprecip%flag,o_Vprecip%name, "precipitation vertical profile", "-")
-   CALL histdef3d(iff,o_ftd%flag,o_ftd%name, "tend temp due aux descentes precip", "-")
-   CALL histdef3d(iff,o_fqd%flag,o_fqd%name,"tend vap eau due aux descentes precip", "-")
+   CALL histdef3d(iff,clef_stations(iff),o_Vprecip%flag,o_Vprecip%name, "precipitation vertical profile", "-")
+   CALL histdef3d(iff,clef_stations(iff),o_ftd%flag,o_ftd%name, "tend temp due aux descentes precip", "-")
+   CALL histdef3d(iff,clef_stations(iff),o_fqd%flag,o_fqd%name,"tend vap eau due aux descentes precip", "-")
  ENDIF !(iflag_con.EQ.3)
 
- CALL histdef3d(iff,o_dtlsc%flag,o_dtlsc%name, "Condensation dT", "K/s")
- CALL histdef3d(iff,o_dtlschr%flag,o_dtlschr%name,"Large-scale condensational heating rate","K/s")
- CALL histdef3d(iff,o_dqlsc%flag,o_dqlsc%name, "Condensation dQ", "(kg/kg)/s")
- CALL histdef3d(iff,o_dtvdf%flag,o_dtvdf%name, "Boundary-layer dT", "K/s")
- CALL histdef3d(iff,o_dqvdf%flag,o_dqvdf%name, "Boundary-layer dQ", "(kg/kg)/s") 
- CALL histdef3d(iff,o_dteva%flag,o_dteva%name, "Reevaporation dT", "K/s")
- CALL histdef3d(iff,o_dqeva%flag,o_dqeva%name, "Reevaporation dQ", "(kg/kg)/s")
- CALL histdef3d(iff,o_ptconv%flag,o_ptconv%name, "POINTS CONVECTIFS", " ")
- CALL histdef3d(iff,o_ratqs%flag,o_ratqs%name, "RATQS", " ")
- CALL histdef3d(iff,o_dtthe%flag,o_dtthe%name, "Dry adjust. dT", "K/s")
+ CALL histdef3d(iff,clef_stations(iff),o_dtlsc%flag,o_dtlsc%name, "Condensation dT", "K/s")
+ CALL histdef3d(iff,clef_stations(iff),o_dtlschr%flag,o_dtlschr%name,"Large-scale condensational heating rate","K/s")
+ CALL histdef3d(iff,clef_stations(iff),o_dqlsc%flag,o_dqlsc%name, "Condensation dQ", "(kg/kg)/s")
+ CALL histdef3d(iff,clef_stations(iff),o_dtvdf%flag,o_dtvdf%name, "Boundary-layer dT", "K/s")
+ CALL histdef3d(iff,clef_stations(iff),o_dqvdf%flag,o_dqvdf%name, "Boundary-layer dQ", "(kg/kg)/s") 
+ CALL histdef3d(iff,clef_stations(iff),o_dteva%flag,o_dteva%name, "Reevaporation dT", "K/s")
+ CALL histdef3d(iff,clef_stations(iff),o_dqeva%flag,o_dqeva%name, "Reevaporation dQ", "(kg/kg)/s")
+ CALL histdef3d(iff,clef_stations(iff),o_ptconv%flag,o_ptconv%name, "POINTS CONVECTIFS", " ")
+ CALL histdef3d(iff,clef_stations(iff),o_ratqs%flag,o_ratqs%name, "RATQS", " ")
+ CALL histdef3d(iff,clef_stations(iff),o_dtthe%flag,o_dtthe%name, "Thermal dT", "K/s")
 
 if(iflag_thermals.gt.1) THEN
- CALL histdef3d(iff,o_dqlscth%flag,o_dqlscth%name, "dQ therm.", "(kg/kg)/s")
- CALL histdef3d(iff,o_dqlscst%flag,o_dqlscst%name, "dQ strat.", "(kg/kg)/s")
- CALL histdef3d(iff,o_dtlscth%flag,o_dtlscth%name, "dQ therm.", "K/s")
- CALL histdef3d(iff,o_dtlscst%flag,o_dtlscst%name, "dQ strat.", "K/s")
- CALL histdef2d(iff,o_plulth%flag,o_plulth%name, "Rainfall therm.", "K/s")
- CALL histdef2d(iff,o_plulst%flag,o_plulst%name, "Rainfall strat.", "K/s")
- CALL histdef2d(iff,o_lmaxth%flag,o_lmaxth%name, "Upper level thermals", "")
- CALL histdef3d(iff,o_ptconvth%flag,o_ptconvth%name, "POINTS CONVECTIFS therm.", " ")
- CALL histdef3d(iff,o_f_th%flag,o_f_th%name, "Thermal plume mass flux", "K/s")
- CALL histdef3d(iff,o_e_th%flag,o_e_th%name,"Thermal plume entrainment","K/s")
- CALL histdef3d(iff,o_w_th%flag,o_w_th%name,"Thermal plume vertical velocity","m/s")
- CALL histdef3d(iff,o_lambda_th%flag,o_lambda_th%name,"Thermal plume vertical velocity","m/s")
- CALL histdef2d(iff,o_ftime_th%flag,o_ftime_th%name,"Fraction of time Shallow convection occurs"," ")
- CALL histdef3d(iff,o_q_th%flag,o_q_th%name, "Thermal plume total humidity", "kg/kg")
- CALL histdef3d(iff,o_a_th%flag,o_a_th%name, "Thermal plume fraction", "")
- CALL histdef3d(iff,o_d_th%flag,o_d_th%name, "Thermal plume detrainment", "K/s")
-!IM endif !iflag_thermals.gt.1
- CALL histdef2d(iff,o_f0_th%flag,o_f0_th%name, "Thermal closure mass flux", "K/s")
- CALL histdef2d(iff,o_zmax_th%flag,o_zmax_th%name, "Thermal plume height", "K/s")
- CALL histdef3d(iff,o_dqthe%flag,o_dqthe%name, "Dry adjust. dQ", "(kg/kg)/s")
+ CALL histdef3d(iff,clef_stations(iff),o_dqlscth%flag,o_dqlscth%name, "dQ therm.", "(kg/kg)/s")
+ CALL histdef3d(iff,clef_stations(iff),o_dqlscst%flag,o_dqlscst%name, "dQ strat.", "(kg/kg)/s")
+ CALL histdef3d(iff,clef_stations(iff),o_dtlscth%flag,o_dtlscth%name, "dQ therm.", "K/s")
+ CALL histdef3d(iff,clef_stations(iff),o_dtlscst%flag,o_dtlscst%name, "dQ strat.", "K/s")
+ CALL histdef2d(iff,clef_stations(iff),o_plulth%flag,o_plulth%name, "Rainfall therm.", "K/s")
+ CALL histdef2d(iff,clef_stations(iff),o_plulst%flag,o_plulst%name, "Rainfall strat.", "K/s")
+ CALL histdef2d(iff,clef_stations(iff),o_lmaxth%flag,o_lmaxth%name, "Upper level thermals", "")
+ CALL histdef3d(iff,clef_stations(iff),o_ptconvth%flag,o_ptconvth%name, "POINTS CONVECTIFS therm.", " ")
+ CALL histdef3d(iff,clef_stations(iff),o_f_th%flag,o_f_th%name, "Thermal plume mass flux", "kg/(m2*s)")
+ CALL histdef3d(iff,clef_stations(iff),o_e_th%flag,o_e_th%name,"Thermal plume entrainment","K/s")
+ CALL histdef3d(iff,clef_stations(iff),o_w_th%flag,o_w_th%name,"Thermal plume vertical velocity","m/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_lambda_th%flag,o_lambda_th%name,"Thermal plume vertical velocity","m/s")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_ftime_th%flag,o_ftime_th%name,"Fraction of time Shallow convection occurs"," ")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_q_th%flag,o_q_th%name, "Thermal plume total humidity", "kg/kg")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_a_th%flag,o_a_th%name, "Thermal plume fraction", "")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_d_th%flag,o_d_th%name, "Thermal plume detrainment", "K/s")
+
+ CALL histdef2d(iff,clef_stations(iff), &
+o_f0_th%flag,o_f0_th%name, "Thermal closure mass flux", "K/s")
+ CALL histdef2d(iff,clef_stations(iff), &
+o_zmax_th%flag,o_zmax_th%name, "Thermal plume height", "K/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dqthe%flag,o_dqthe%name, "Thermal dQ", "(kg/kg)/s")
 endif !iflag_thermals.gt.1
- CALL histdef3d(iff,o_dtajs%flag,o_dtajs%name, "Dry adjust. dT", "K/s")
- CALL histdef3d(iff,o_dqajs%flag,o_dqajs%name, "Dry adjust. dQ", "(kg/kg)/s")
- CALL histdef3d(iff,o_dtswr%flag,o_dtswr%name, "SW radiation dT", "K/s")
- CALL histdef3d(iff,o_dtsw0%flag,o_dtsw0%name, "CS SW radiation dT", "K/s")
- CALL histdef3d(iff,o_dtlwr%flag,o_dtlwr%name, "LW radiation dT", "K/s")
- CALL histdef3d(iff,o_dtlw0%flag,o_dtlw0%name, "CS LW radiation dT", "K/s")
- CALL histdef3d(iff,o_dtec%flag,o_dtec%name, "Cinetic dissip dT", "K/s")
- CALL histdef3d(iff,o_duvdf%flag,o_duvdf%name, "Boundary-layer dU", "m/s2")
- CALL histdef3d(iff,o_dvvdf%flag,o_dvvdf%name, "Boundary-layer dV", "m/s2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dtajs%flag,o_dtajs%name, "Dry adjust. dT", "K/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dqajs%flag,o_dqajs%name, "Dry adjust. dQ", "(kg/kg)/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dtswr%flag,o_dtswr%name, "SW radiation dT", "K/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dtsw0%flag,o_dtsw0%name, "CS SW radiation dT", "K/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dtlwr%flag,o_dtlwr%name, "LW radiation dT", "K/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dtlw0%flag,o_dtlw0%name, "CS LW radiation dT", "K/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dtec%flag,o_dtec%name, "Cinetic dissip dT", "K/s")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_duvdf%flag,o_duvdf%name, "Boundary-layer dU", "m/s2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dvvdf%flag,o_dvvdf%name, "Boundary-layer dV", "m/s2")
 
      IF (ok_orodr) THEN
- CALL histdef3d(iff,o_duoro%flag,o_duoro%name, "Orography dU", "m/s2")
- CALL histdef3d(iff,o_dvoro%flag,o_dvoro%name, "Orography dV", "m/s2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_duoro%flag,o_duoro%name, "Orography dU", "m/s2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dvoro%flag,o_dvoro%name, "Orography dV", "m/s2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dtoro%flag,o_dtoro%name, "Orography dT", "K/s")
      ENDIF
 
      IF (ok_orolf) THEN
- CALL histdef3d(iff,o_dulif%flag,o_dulif%name, "Orography dU", "m/s2")
- CALL histdef3d(iff,o_dvlif%flag,o_dvlif%name, "Orography dV", "m/s2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dulif%flag,o_dulif%name, "Orography dU", "m/s2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dvlif%flag,o_dvlif%name, "Orography dV", "m/s2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dtlif%flag,o_dtlif%name, "Orography dT", "K/s")
      ENDIF
+
+     IF (ok_hines) then
+ CALL histdef3d(iff,clef_stations(iff), &
+o_duhin%flag,o_duhin%name, "Hines GWD dU", "m/s2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dvhin%flag,o_dvhin%name, "Hines GWD dV", "m/s2")
+
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dthin%flag,o_dthin%name, "Hines GWD dT", "K/s")
+     ENDIF
+
+ CALL histdef3d(iff,clef_stations(iff), &
+o_rsu%flag,o_rsu%name, "SW upward radiation", "W m-2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_rsd%flag,o_rsd%name, "SW downward radiation", "W m-2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_rlu%flag,o_rlu%name, "LW upward radiation", "W m-2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_rld%flag,o_rld%name, "LW downward radiation", "W m-2")
+
+ CALL histdef3d(iff,clef_stations(iff), &
+o_rsucs%flag,o_rsucs%name, "SW CS upward radiation", "W m-2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_rsdcs%flag,o_rsdcs%name, "SW CS downward radiation", "W m-2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_rlucs%flag,o_rlucs%name, "LW CS upward radiation", "W m-2")
+ CALL histdef3d(iff,clef_stations(iff), &
+o_rldcs%flag,o_rldcs%name, "LW CS downward radiation", "W m-2")
+ 
+ CALL histdef3d(iff,clef_stations(iff), &
+o_tnt%flag,o_tnt%name, "Tendency of air temperature", "K s-1")
+
+ CALL histdef3d(iff,clef_stations(iff), &
+o_tntc%flag,o_tntc%name, "Tendency of air temperature due to Moist Convection", &
+"K s-1")
+
+ CALL histdef3d(iff,clef_stations(iff), &
+o_tntr%flag,o_tntr%name, "Air temperature tendency due to Radiative heating", &
+"K s-1")
+
+ CALL histdef3d(iff,clef_stations(iff), &
+o_tntscpbl%flag,o_tntscpbl%name, "Air temperature tendency due to St cloud and precipitation and BL mixing", &
+"K s-1")
+
+ CALL histdef3d(iff,clef_stations(iff), &
+o_tnhus%flag,o_tnhus%name, "Tendency of specific humidity", "s-1")
+
+ CALL histdef3d(iff,clef_stations(iff), &
+o_tnhusc%flag,o_tnhusc%name, "Tendency of specific humidity due to convection", "s-1")
+
+ CALL histdef3d(iff,clef_stations(iff), &
+o_tnhusscpbl%flag,o_tnhusscpbl%name, "Tendency of Specific humidity due to ST cl, precip and BL mixing", &
+"s-1")
+
+ CALL histdef3d(iff,clef_stations(iff), &
+o_evu%flag,o_evu%name, "Eddy viscosity coefficient for Momentum Variables", "m2 s-1")
+
+ CALL histdef3d(iff,clef_stations(iff), &
+o_h2o%flag,o_h2o%name, "Mass Fraction of Water", "1")
+
+ CALL histdef3d(iff,clef_stations(iff), &
+o_mcd%flag,o_mcd%name, "Downdraft COnvective Mass Flux", "kg/(m2*s)")
+
+ CALL histdef3d(iff,clef_stations(iff), &
+o_dmc%flag,o_dmc%name, "Deep COnvective Mass Flux", "kg/(m2*s)")
+
+ CALL histdef3d(iff,clef_stations(iff), &
+o_ref_liq%flag,o_ref_liq%name, "Effective radius of convective cloud liquid water particle", "m")
+
+ CALL histdef3d(iff,clef_stations(iff), &
+o_ref_ice%flag,o_ref_ice%name, "Effective radius of startiform cloud ice particle", "m")
+
+   if (RCO2_per.NE.RCO2_act.OR.RCH4_per.NE.RCH4_act.OR. &
+    RN2O_per.NE.RN2O_act.OR.RCFC11_per.NE.RCFC11_act.OR. &
+    RCFC12_per.NE.RCFC12_act) THEN
+
+ CALL histdef2d(iff,clef_stations(iff),o_rsut4co2%flag,o_rsut4co2%name, &
+ "TOA Out SW in 4xCO2 atmosphere", "W/m2") 
+CALL histdef2d(iff,clef_stations(iff),o_rlut4co2%flag,o_rlut4co2%name, &
+"TOA Out LW in 4xCO2 atmosphere", "W/m2") 
+CALL histdef2d(iff,clef_stations(iff),o_rsutcs4co2%flag,o_rsutcs4co2%name, &
+"TOA Out CS SW in 4xCO2 atmosphere", "W/m2") 
+CALL histdef2d(iff,clef_stations(iff),o_rlutcs4co2%flag,o_rlutcs4co2%name, &
+"TOA Out CS LW in 4xCO2 atmosphere", "W/m2") 
+
+CALL histdef3d(iff,clef_stations(iff),o_rsu4co2%flag,o_rsu4co2%name, &
+"Upwelling SW 4xCO2 atmosphere", "W/m2") 
+CALL histdef3d(iff,clef_stations(iff),o_rlu4co2%flag,o_rlu4co2%name, &
+"Upwelling LW 4xCO2 atmosphere", "W/m2") 
+CALL histdef3d(iff,clef_stations(iff),o_rsucs4co2%flag,o_rsucs4co2%name, &
+"Upwelling CS SW 4xCO2 atmosphere", "W/m2") 
+CALL histdef3d(iff,clef_stations(iff),o_rlucs4co2%flag,o_rlucs4co2%name, &
+"Upwelling CS LW 4xCO2 atmosphere", "W/m2") 
+
+ CALL histdef3d(iff,clef_stations(iff),o_rsd4co2%flag,o_rsd4co2%name, &
+ "Downwelling SW 4xCO2 atmosphere", "W/m2") 
+ CALL histdef3d(iff,clef_stations(iff),o_rld4co2%flag,o_rld4co2%name, &
+"Downwelling LW 4xCO2 atmosphere", "W/m2") 
+ CALL histdef3d(iff,clef_stations(iff),o_rsdcs4co2%flag,o_rsdcs4co2%name, &
+"Downwelling CS SW 4xCO2 atmosphere", "W/m2") 
+ CALL histdef3d(iff,clef_stations(iff),o_rldcs4co2%flag,o_rldcs4co2%name, &
+"Downwelling CS LW 4xCO2 atmosphere", "W/m2") 
+
+   endif
 
 
@@ -1257,6 +1690,7 @@
      DO iq=3,nqtot  
        iiq=niadv(iq)
-       o_trac(iq-2) = ctrl_out((/ 4, 5, 1, 1, 1 /),tname(iiq))
-       CALL histdef3d (iff, o_trac(iq-2)%flag,o_trac(iq-2)%name,'Tracer '//ttext(iiq), "-" )
+       o_trac(iq-2) = ctrl_out((/ 4, 5, 1, 1, 1, 10 /),tname(iiq))
+       CALL histdef3d (iff,clef_stations(iff), &
+ o_trac(iq-2)%flag,o_trac(iq-2)%name,'Tracer '//ttext(iiq), "-" )
      ENDDO
     ENDIF
@@ -1273,9 +1707,10 @@
       end subroutine phys_output_open
 
-      SUBROUTINE histdef2d (iff,flag_var,nomvar,titrevar,unitvar)
+      SUBROUTINE histdef2d (iff,lpoint,flag_var,nomvar,titrevar,unitvar)
       
        use ioipsl
        USE dimphy
        USE mod_phys_lmdz_para
+       USE iophy
 
        IMPLICIT NONE
@@ -1287,4 +1722,5 @@
 
        integer                          :: iff
+       logical                          :: lpoint
        integer, dimension(nfiles)       :: flag_var
        character(len=20)                 :: nomvar
@@ -1302,5 +1738,6 @@
 ! Appel a la lecture des noms et niveau d'ecriture des variables dans output.def
        call conf_physoutputs(nomvar,flag_var)
-       
+      
+       if(.NOT.lpoint) THEN  
        if ( flag_var(iff)<=lev_files(iff) ) then
  call histdef (nid_files(iff),nomvar,titrevar,unitvar, &
@@ -1308,11 +1745,19 @@
                type_ecri(iff), zstophym,zoutm(iff))                
        endif                      
+       else
+       if ( flag_var(iff)<=lev_files(iff) ) then
+ call histdef (nid_files(iff),nomvar,titrevar,unitvar, &
+               npstn,1,nhorim(iff), 1,1,1, -99, 32, &
+               type_ecri(iff), zstophym,zoutm(iff))                
+       endif                      
+       endif                      
       end subroutine histdef2d
 
-      SUBROUTINE histdef3d (iff,flag_var,nomvar,titrevar,unitvar)
+      SUBROUTINE histdef3d (iff,lpoint,flag_var,nomvar,titrevar,unitvar)
 
        use ioipsl
        USE dimphy
        USE mod_phys_lmdz_para
+       USE iophy
 
        IMPLICIT NONE
@@ -1324,4 +1769,5 @@
 
        integer                          :: iff
+       logical                          :: lpoint
        integer, dimension(nfiles)       :: flag_var
        character(len=20)                 :: nomvar
@@ -1340,4 +1786,5 @@
        endif
 
+       if(.NOT.lpoint) THEN
        if ( flag_var(iff)<=lev_files(iff) ) then
           call histdef (nid_files(iff), nomvar, titrevar, unitvar, &
@@ -1345,4 +1792,12 @@
                levmax(iff)-levmin(iff)+1, nvertm(iff), 32, type_ecri(iff), &
                zstophym, zoutm(iff))
+       endif
+       else
+       if ( flag_var(iff)<=lev_files(iff) ) then
+          call histdef (nid_files(iff), nomvar, titrevar, unitvar, &
+               npstn,1,nhorim(iff), klev, levmin(iff), &
+               levmax(iff)-levmin(iff)+1, nvertm(iff), 32, &
+               type_ecri(iff), zstophym,zoutm(iff))
+       endif
        endif
       end subroutine histdef3d
